package com.eactive.eai.transformer.function.crypto;

import java.util.Stack;

import org.nfunk.jep.ParseException;
import org.nfunk.jep.function.PostfixMathCommand;
import java.nio.charset.StandardCharsets;

import org.apache.commons.lang3.StringUtils;
// kj bank import 2025-09-23 jwhong
//import com.eactive.eai.common.seed.SeedKJ;
//security-1.0.0.jar 사용으로 변경 2026-01-05
import com.eactive.eai.security.seed.Seed;
import com.eactive.eai.common.context.ElinkTransactionContext;

public class SeedKJDecrypt extends PostfixMathCommand {
    public SeedKJDecrypt() {
        numberOfParameters = 1;
    }

    public void run(Stack inStack) throws ParseException {
        checkStack(inStack);
        
        String seedKey = ElinkTransactionContext.getSeedKey();
        String decryptKey = StringUtils.leftPad(seedKey, 16, '0');     

        Object param = inStack.pop();

        byte[] value = null;

        if (param instanceof String) {
            value = ((String) param).getBytes();
        } else if (param instanceof byte[]) {
            value = (byte[]) param;
        } else if (param instanceof Double) {
        	if (((Double) param).doubleValue() == Math.round(((Double) param).doubleValue())) {
        		value = new Long(Math.round(((Double) param).doubleValue())).toString().getBytes();
        	} else {
                value =((Number) param).toString().getBytes();
        	}
        } else if (param instanceof Number) {
            value = ((Number) param).toString().getBytes();
        } else if (param == null) {
            inStack.push(null);
            return;
        } else {
            throw new ParseException("Function의 파라미터 인수가 byte[] 또는 String이 아닙니다. : " + param);
        }

        try {
        	String decryptedData = Seed.decrypt(decryptKey, new String(value, StandardCharsets.UTF_8));
        			
        	inStack.push(decryptedData);
        } catch (Exception e) {
            //throw new ExecutionException(e.getMessage(), parameters, e);
            throw new ParseException(e.getMessage(), e);
        }    	
    }
}
